/************************************************************************************/
/*  Program name CAPAPEXT_PAY_DOC.sql                                               */
/*  Creater:  WONG Wing Kin (PCCW - UniHub)                                         */
/*************   History   *************************                                */
/* 30 NOV, 2005   WONG Wing Kin         First created                               */
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
set verify off;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPAPEXT_PAY_DOC';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPAP_PAY_DOC.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO			VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_B (p_NGO VARCHAR2) IS
	SELECT
		F.*,
		B.Name	OU_Name
	FROM
		AP_CHECK_STOCKS_ALL				F,
		HR_ALL_ORGANIZATION_UNITS		B,
		HR_ORGANIZATION_INFORMATION		I
	WHERE	SUBSTR(B.Name,4,4)			=	p_NGO
	AND		B.Organization_ID			=	F.Org_ID
	AND		B.Organization_ID			=	I.Organization_ID
	AND		I.Org_Information_Context	=	'Operating Unit Information';

BEGIN
	lv_NGO			:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_B(lv_NGO) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.Check_Stock_ID||CHR(9)||
				C1.Last_Update_Date||CHR(9)||
					C1.Last_Updated_By||CHR(9)||
				C1.Last_Update_Login||CHR(9)||
				C1.Creation_Date||CHR(9)||
					C1.Created_By||CHR(9)||
				C1.Name||CHR(9)||
					C1.Bank_Account_ID||CHR(9)||				--  Bank Account Mapping
				C1.Disbursement_Type_Lookup_Code||CHR(9)||
					C1.Check_Format_ID||CHR(9)||				--  Check Format Mapping
				C1.Last_Document_Num||CHR(9)||
				C1.Last_Available_Document_Num||CHR(9)||
				C1.Num_Setup_Checks||CHR(9)||
				C1.Auto_Medium_ID||CHR(9)||
				C1.Check_Recon_Group_ID||CHR(9)||
				C1.Sequential_Flag||CHR(9)||
				C1.Inactive_Date||CHR(9)||
					C1.Future_Pay_Code_Combination_ID||CHR(9)||
				C1.Attribute_Category||CHR(9)||
				C1.Attribute1||CHR(9)||
				C1.Attribute2||CHR(9)||
				C1.Attribute3||CHR(9)||
				C1.Attribute4||CHR(9)||
				C1.Attribute5||CHR(9)||
				C1.Attribute6||CHR(9)||
				C1.Attribute7||CHR(9)||
				C1.Attribute8||CHR(9)||
				C1.Attribute9||CHR(9)||
				C1.Attribute10||CHR(9)||
				C1.Attribute11||CHR(9)||
				C1.Attribute12||CHR(9)||
				C1.Attribute13||CHR(9)||
				C1.Attribute14||CHR(9)||
				C1.Attribute15||CHR(9)||
				C1.Doc_Category_Code||CHR(9)||
					C1.Org_ID||CHR(9)||
					C1.Bank_Charges_CCID||CHR(9)||
					C1.Bank_Errors_CCID||CHR(9)||
				C1.Clearing_Days||CHR(9)||
				C1.Future_Dated_Payments_Flag||CHR(9)||
					C1.Cash_Clearing_CCID||CHR(9)||
				C1.Transmission_Code||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Last_Updated_By)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.Created_By)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Future_Pay_Code_Combination_ID)||CHR(9)||
				C1.OU_Name||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Bank_Charges_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Bank_Errors_CCID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.Cash_Clearing_CCID)
			);
			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/